#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Oct 23 14:27:08 2018

@author: lessig
"""

import numpy as np
import lightprobe as lp
import matplotlib.pyplot as plt

def cost( t) :
    return np.cos( t)


def midpointR1( f, nt, max_t = np.pi) :
    
    ht = max_t / nt
    
    ival = 0.
    
    for t in np.linspace( 0., max_t, nt) :
        ival += ht * f(t)
    
    return ival


    
results = [];
ns = [];

for i in range( 1, 512) :
    ival = midpointR1( cost, 32*i, np.pi / 2.)
    results.append( np.abs(ival))
    ns.append( 64*i)


plt.figure();
plt.plot( ns, np.abs(np.array(results) - 1.0))
plt.plot( ns, 0.4*np.power( np.array(ns), -1.))
plt.show()