#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Oct 16 14:07:47 2018

@author: lessig
"""

import numpy as np
import lightprobe as lp
import matplotlib.pyplot as plt


def costheta( theta, phi) :
    return np.cos( theta)
    

def cos5deg( theta, phi) :
    ret = 0
    if( theta < 0.087266462599716474) :
        ret = 1
    return ret 
    

def midpointS2( f, ntheta, nphi, theta_max = np.pi) :
    
    dtheta = theta_max / ntheta;
    dphi = (2.0 * np.pi) / nphi;
    
    ival = 0.
    for theta in np.linspace( 0.0, theta_max, ntheta) :
        for phi in np.linspace( 0.0, 2.0*np.pi, nphi) :
            
            ival += dtheta * dphi * np.sin(theta) * f(theta,phi)
            
    return ival
            

def midpointMeasurement( f, ntheta, nphi, theta_max = np.pi) :
    
    dtheta = (np.pi / 2.0) / ntheta;
    dphi = (2.0 * np.pi) / nphi;
    
    ival = 0.
    for theta in np.linspace( 0.0, theta_max, ntheta) :
        for phi in np.linspace( 0.0, 2.0*np.pi, nphi) :
            
            ival += dtheta * dphi * np.cos(theta) * np.sin(theta) * f(theta,phi)
            
    return ival

    
#####################################################################
results = [];
ns = [];

for i in range( 1, 14) :
#    ival = midpointS2( costheta, 32*i, 64*i, np.pi / 2.)
    ival = midpointMeasurement( lp.lightprobe, 32*i, 64*i, np.pi / 2.)
    results.append( ival)
    ns.append( 32*i * 64*i)


plt.figure();
plt.plot( ns, np.abs( np.abs(np.array(results) - np.pi  )))
#plt.plot( ns, 5 * np.power( np.array(ns), -0.5))
plt.show()